<?php if (!defined('BILLING_MODULE')) die("Hacking attempt!");

/**
 * RuKassa
 *
 * @link          https://rukassa.is/
 */
class RuKassa
{
    var $doc = 'https://lk.rukassa.is/main/modules';

    function Settings($config)
    {
        $html = [];

        $html[] = [
            'ID Магазина:',
            'Из настроек магазина в личном кабинете rukassa.is',
            '<input name="save_con[shop_id]" class="edit bk" type="text" value="' . $config['shop_id'] . '" style="width: 100%">',
        ];

        $html[] = [
            'API TOKEN:',
			'Из настроек магазина в личном кабинете rukassa.is',
            '<input name="save_con[api_key]" class="edit bk" type="password" value="' . $config['api_key'] . '" style="width: 100%">',
        ];

        $html[] = [
            'IP фильтр:',
            'Список доверенных IP-адресов, наши адреса: 45.82.69.117',
            '<input name="save_con[ip_filter]" class="edit bk" type="text" value="' . $config['ip_filter'] . '" style="width: 100%">',
        ];


        return $html;
    }

    function Form($order_id, $config, $invoice, $description, $DevTools)
    {
        $amount = number_format($invoice['invoice_pay'], 2, '.', '') * 1;

        if (empty($description)) {
            $description = 'Balance ' . $invoice['invoice_user_name'];
        }
		
		$forms = [
			'shop_id'	=> $config['shop_id'],
			'token'		=> $config['api_key'],
			'order_id' 	=> $order_id,
			'amount' 	=> $amount,
		];

		$ch = curl_init('https://lk.rukassa.is/api/v1/create');
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($forms, '', '&'));
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_HEADER, false);
		$result = json_decode(curl_exec($ch));
		curl_close($ch);
		if(!isset($result->id) || !isset($result->hash) || !isset($result->url)){
			return "<a style='color=#ffffff'>".$result->message ."</a>";
		}
		return "<a href=".$result->url." id='paysys_form' style='color=#ffffff'>Оплатить</a>";
	}

    function check_id($data)
    {
        return $data["order_id"];
    }

    function check_ok($data)
    {
        return 'OK';
    }

    function check_out($data, $config, $invoice)
    {
        global $_REQUEST, $_SERVER;

        $valid_ip = false;
        $sIP = str_replace(' ', '', $config['ip_filter']);
        $array_IP = explode(',', $sIP);
        if (isset($_SERVER["HTTP_X_REAL_IP"])) {
            $cur_ip = $_SERVER["HTTP_X_REAL_IP"];
        }elseif (isset($_SERVER["HTTP_CF_CONNECTING_IP"])) {
            $cur_ip = $_SERVER["HTTP_CF_CONNECTING_IP"];
        } else {
            $cur_ip = $_SERVER["REMOTE_ADDR"];
        }
        if (in_array($cur_ip, $array_IP)) {
            $valid_ip = true;
        }

        if (!$valid_ip) {
            return 'Error: ip_checked';
        } 
		
		$signatureGen =  hash_hmac('sha256', $_REQUEST['id'] . '|' . $_REQUEST['createdDateTime'] . '|' . $_REQUEST['amount'], $config['api_key']);

        if ((string)$signatureGen != (string)$_SERVER['HTTP_SIGNATURE']) {
            return 'Error: signature:: ' . $_SERVER['HTTP_SIGNATURE'] . ' != ' . $signatureGen;
        } 
		
		if ($_REQUEST['in_amount'] < $_REQUEST['amount']) {
			return 'Error: amount:: ' . $_REQUEST['in_amount'] . ' < ' . $_REQUEST['amount'];
		}
		
		return 200;
    }
}

$Paysys = new RuKassa;
